<?php
// $Id$
/**
 * @file
 * Contains the basic 'wowtoon' field handler.
 */

/**
 * Field handler to provide image / text display of wowtoon_entity items.
 */
class wowtoon_handler_field_wowtoon_entity extends views_handler_field {

  function construct() {
    parent::construct();
    if ($this->definition['field'] == 'class') {
      $this->additional_fields['classid'] = 'classid';
      $this->additional_fields['class'] = 'class';
    }
    elseif ($this->definition['field'] == 'race') {
      $this->additional_fields['raceid'] = 'raceid';
      $this->additional_fields['race'] = 'race';
      $this->additional_fields['genderid'] = 'genderid';
      $this->additional_fields['gender'] = 'gender';
    }
  }  

  function option_definition() {
    $options = parent::option_definition();
    $options['display_type'] = array('default' => 1);
    return $options;
  }

  /**
   * Provide link to node option
   */
  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    if ($this->definition['field'] == 'class' || $this->definition['field'] == 'race') {
      $form['display_type'] = array(
        '#title' => t('Display as'),
        '#type' => 'radios',
        '#options' => array(0 => 'text', 1 => 'image'),
        '#description' => t('Display as plain text, or an 18x18 icon.'),
        '#default_value' => isset($this->options['display_type'])?$this->options['display_type']:1,
      );
    }
  }

  function query() {
    $this->ensure_my_table();
    $this->add_additional_fields();
  }
  
  function render($values) {
    if ($this->definition['field'] == 'class') {
      $txt = $values->wowtoon_entity_class;
      $img = sprintf('<img src="http://us.battle.net/wow/static/images/icons/class/%d.gif" title="%s" width="18" height="18" />', $values->wowtoon_entity_classid, check_plain($values->wowtoon_entity_class)); 
    }
    elseif ($this->definition['field'] == 'race') {
      $txt = $values->wowtoon_entity_race;
      $img = sprintf('<img src="http://us.battle.net/wow/static/images/icons/race/%d-%d.gif" title="%s" width="18" height="18" />', $values->wowtoon_entity_raceid, $values->wowtoon_entity_genderid, check_plain($values->wowtoon_entity_race));
    }
    //kpr($this->aliases, true)
    $display = isset($this->options['display_type'])?$this->options['display_type']:1;
    switch ($display) {
      case 0:
        return $txt;
        break;
      case 1:
      default:
        return $img; 
    }
  }
}
